<?php
/*
Plugin Name: Flash Flickr Slideshow
Plugin URI: http://www.sephiroth.it
Description: Display a flash flickr slideshow widget from user's photostream. You will need a valid <a href="http://www.flickr.com/services/apps/create/apply">Flickr API</a> key
Version: 0.3
Author: Alessandro Crugnola
Author URI: http://www.sephiroth.it
*/

class FlashFlickrPS_Widget extends WP_Widget {

    function FlashFlickrPS_Widget() {
        $widget_ops = array('classname' => 'widget_flashflickrps', 'description' => 'Display a Flash Flickr slideshow of an user photostream');
        $this->WP_Widget('flashflickrps', 'Flash Flickr Photostream', $widget_ops);
    }
 
    function widget($args, $instance) {
        extract($args);
        
		echo $before_widget.$before_title.$instance['title'].$after_title;

        ?>

		<div id="flashflickrpsContent">
        	<p>
	        	To view this page ensure that Adobe Flash Player version 
				10.0.0 or greater is installed. 
			</p>
			<script type="text/javascript"> 
				var pageHost = ((document.location.protocol == "https:") ? "https://" :	"http://"); 
				document.write("<a href='http://www.adobe.com/go/getflashplayer'><img src='" 
								+ pageHost + "www.adobe.com/images/shared/download_buttons/get_flash_player.gif' alt='Get Adobe Flash player' /></a>" ); 
			</script> 
        </div>

		<script type="text/javascript">
		   	var so = new SWFObject("<?php echo get_plugin_url(); ?>/media/flickr_widget.swf", "flickr_widget", "<?php echo $instance['widget_width']; ?>", "<?php echo $instance['widget_height']; ?>", "10", "#FFFFFF");
			so.useExpressInstall( "<?php echo get_plugin_url(); ?>/media/playerProductInstall.swf" );
		   	so.addParam("quality", "high");
		   	so.addParam("wmode", "transparent");
		   	so.addParam("salign", "tl");
		   	so.addVariable("username", "<?php echo $instance['username']; ?>");
		   	so.addVariable("api_key", "<?php echo $instance['api_key']; ?>");
		   	so.addVariable("timer", "<?php echo $instance['slideshow_timer']; ?>");
		   	so.addVariable("image_type", "<?php echo $instance['image_type']; ?>");
		   	so.addVariable("use_frame", "<?php echo $instance['useframe']; ?>");
		   	so.addVariable("frame_color", "<?php echo $instance['frame_color']; ?>");
		   	so.addVariable("use_shadow", "<?php echo $instance['useshadow']; ?>");
		   	so.addVariable("frame_size", "<?php echo $instance['frame_size']; ?>");
		   	so.write("flashflickrpsContent");
		</script>

		<?php
        echo $after_widget;
    }
 
    function update($new_instance, $old_instance) {
        $instance = $old_instance;
        
        $instance['title'] = (empty($new_instance['title'])) ? "Flickr" : strip_tags($new_instance['title']);
        $instance['username'] = (empty($new_instance['username'])) ? "" : strip_tags($new_instance['username']);
        $instance['slideshow_timer'] = ((int)$new_instance['slideshow_timer'] > 0) ? (int)$new_instance['slideshow_timer'] : 2000;
		$instance['api_key'] = (empty($new_instance['api_key'])) ? "" : strip_tags($new_instance['api_key']);
		$instance['image_type'] = (empty($new_instance['image_type'])) ? "s" : strip_tags($new_instance['image_type']);
		$instance['useframe'] = (isset($new_instance['useframe'])) ? 1 : 0;
		$instance['useshadow'] = (isset($new_instance['useshadow'])) ? 1 : 0;
		$instance['widget_height'] = (isset($new_instance['widget_height'])) ? strip_tags($new_instance['widget_height']) : "100%";
		$instance['widget_width'] = (isset($new_instance['widget_width'])) ? strip_tags($new_instance['widget_width']) : "100%";
		$instance['frame_color'] = (empty($new_instance['frame_color'])) ? "#FFFFFF" : strip_tags($new_instance['frame_color']);
		$instance['frame_size'] = (isset($new_instance['frame_size'])) ? strip_tags($new_instance['frame_size']) : "5";
        return $instance;
    }

    function form($instance) {
        $instance = wp_parse_args( (array) $instance, array( 
				'username' => '',
				'order' => '', 
				'slideshow_timer' => 5000, 
				'ct' => '', 
				"title" => "Flickr", 
				"username" => "", 
				"useframe" => true,
				"useshadow" => true,
				"frame_color" => "0xFFFFFF",
				"image_type" => "s",
				"widget_height" => "100%",
				"widget_width" => "100%",
				"frame_size" => "5",
				"api_key" => "" ) );

        $title = (empty($instance['title'])) ? "Title" : strip_tags($instance['title']);
        $username = (empty($instance['username'])) ? "acrugnola" : strip_tags($instance['username']);
        $timer = ((int)$instance['slideshow_timer'] > 0) ? (int)$instance['slideshow_timer'] : 2000;
		$api_key = (empty($instance['api_key'])) ? "ac2255e9ab52edad6a5cfbca20b71486" : strip_tags($instance['api_key']);
		$image_type = (empty($instance['image_type'])) ? "s" : $instance['image_type'];
		$use_frame = isset($instance['useframe']) ? $instance['useframe'] : false;
		$use_shadow = isset($instance['useshadow']) ? $instance['useshadow'] : false;
		$frame_color = (empty($instance['frame_color'])) ? "0xFFFFFF" : strip_tags($instance['frame_color']);
		$widget_height = isset($instance['widget_height']) ? $instance['widget_height'] : "100%";
		$widget_width = isset($instance['widget_width']) ? $instance['widget_width'] : "100%";
		$frame_size = isset($instance['frame_size']) ? $instance['frame_size'] : "5";
		
        ?>
        <p><?php echo $this->errors ?></p>
        
		<!-- title -->
		<p>
            <label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?></label>
            <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" />
        </p>

		<!-- username -->
		<p>
            <label for="<?php echo $this->get_field_id('username'); ?>"><?php _e('Username:'); ?></label>
            <input class="widefat" id="<?php echo $this->get_field_id('username'); ?>" name="<?php echo $this->get_field_name('username'); ?>" type="text" value="<?php echo $username; ?>" />
        </p>

		<!-- slideshow timer -->
        <p>
            <label for="<?php echo $this->get_field_id('slideshow_timer'); ?>"><?php _e("Slideshow Timer: "); ?></label>
            <input class="widefat" id="<?php echo $this->get_field_id('slideshow_timer'); ?>" name="<?php echo $this->get_field_name('slideshow_timer'); ?>" type="text" value="<?php echo $timer; ?>" />
        </p>

		<!-- widget width -->
        <p>
            <label for="<?php echo $this->get_field_id('widget_width'); ?>"><?php _e("Flash width: "); ?></label>
            <input class="widefat" id="<?php echo $this->get_field_id('widget_width'); ?>" name="<?php echo $this->get_field_name('widget_width'); ?>" type="text" value="<?php echo $widget_width; ?>" />
        </p>

		<!-- widget height -->
        <p>
            <label for="<?php echo $this->get_field_id('widget_height'); ?>"><?php _e("Flash height: "); ?></label>
            <input class="widefat" id="<?php echo $this->get_field_id('widget_height'); ?>" name="<?php echo $this->get_field_name('widget_height'); ?>" type="text" value="<?php echo $widget_height; ?>" />
        </p>

		<!-- frame size -->
        <p>
            <label for="<?php echo $this->get_field_id('frame_size'); ?>"><?php _e("Frame size: "); ?></label>
            <input class="widefat" id="<?php echo $this->get_field_id('frame_size'); ?>" name="<?php echo $this->get_field_name('frame_size'); ?>" type="text" value="<?php echo $frame_size; ?>" />
        </p>

		<!-- api key -->
		<p>
            <label for="<?php echo $this->get_field_id('api_key'); ?>"><?php _e("Api Key: "); ?></label>
            <input class="widefat" id="<?php echo $this->get_field_id('api_key'); ?>" name="<?php echo $this->get_field_name('api_key'); ?>" type="text" value="<?php echo $api_key; ?>" />
			<br />
	        <label for="<?php echo $this->get_field_id('frame_color'); ?>"><?php _e("Frame Color: "); ?></label>
       		<input class="widefat" id="<?php echo $this->get_field_id('frame_color'); ?>" name="<?php echo $this->get_field_name('frame_color'); ?>" type="text" value="<?php echo $frame_color; ?>" />
        </p>

		<p>
			<label for="<?php echo $this->get_field_id('image_type'); ?>"><?php _e("Image type: "); ?>
				<select id="<?php echo $this->get_field_id( 'image_type' ); ?>" name="<?php echo $this->get_field_name( 'image_type' ); ?>" class="widefat" style="width:100%;">
					<option value="s" <?php if ( 's' == $instance['image_type'] ) echo 'selected="selected"'; ?>><?php _e("Small square"); ?></option>
					<option value="t" <?php if ( 't' == $instance['image_type'] ) echo 'selected="selected"'; ?>><?php _e("Thumbnail"); ?></option>
					<option value="m" <?php if ( 'm' == $instance['image_type'] ) echo 'selected="selected"'; ?>><?php _e("Small"); ?></option>
					<option value="-" <?php if ( '-' == $instance['image_type'] ) echo 'selected="selected"'; ?>><?php _e("Medium"); ?></option>
					<option value="b" <?php if ( 'b' == $instance['image_type'] ) echo 'selected="selected"'; ?>><?php _e("Large"); ?></option>
				</select>
				
			</label>
		</p>


		<p>
			<input type="checkbox" class="checkbox" id="<?php echo $this->get_field_id('useframe');?>" name="<?php echo $this->get_field_name('useframe');?>" <?php checked( $instance['useframe'], true ); ?> />
            <label for="<?php echo $this->get_field_id('useframe'); ?>"><?php _e("Use Frame"); ?></label>
			<br />
			<input type="checkbox" class="checkbox" id="<?php echo $this->get_field_id('useshadow');?>" name="<?php echo $this->get_field_name('useshadow');?>" <?php checked( $instance['useshadow'], true ); ?> />
            <label for="<?php echo $this->get_field_id('useshadow'); ?>"><?php _e("Use Shadow"); ?></label>
        </p>

    <?
    }
}


function get_content_dir()
{
  if ( !defined('WP_CONTENT_DIR') )
    define( 'WP_CONTENT_DIR', ABSPATH . 'wp-content' );
  return WP_CONTENT_DIR;
}

function get_plugin_dir()
{
  return get_content_dir().'/plugins/'.plugin_basename(dirname(__FILE__));
}

function get_plugin_url()
{
  if ( !defined('WP_CONTENT_URL') )
    define( 'WP_CONTENT_URL', get_option('siteurl') . '/wp-content');
  return WP_CONTENT_URL.'/plugins/'.plugin_basename(dirname(__FILE__));
}

function register_swfobject()
{
	echo "<script type=\"text/javascript\" src=\"" . get_plugin_url() . "/media/swfobject.js\"></script>";
}

function reg_flash_flickr_ps()
{
    register_widget('FlashFlickrPS_Widget');
}

add_action('wp_head', 'register_swfobject');
add_action('init', 'reg_flash_flickr_ps', 1);

?>